#include "config.h"
#include "string.h"
#include "ai_usb.h"

#define Mouse_InterfaceNum 3
#define Mouse_EP 3
//ֻ
#define Mouse_IN_SIZE 5

void initMouse();
void mouseRun(u8);

extern BYTE bKeyCode;
extern BYTE bKeyDebounce;
extern BOOL fKeyOK;
BOOL mouseInBusy;
BYTE lastMouseCode;

sbit MOUSE34 = P3^4;
sbit MOUSE35 = P3^5;

//дģʽ
BYTE isPenModel;
//дʰ
BYTE isLockPenDown;

u16 lastMouseAbsPosX;
u16 lastMouseAbsPosY;

u16 mouseAbsPosX;
u16 mouseAbsPosY;
//00,Ͻ, (32768,32768)½,x
void setMouseAbsPos(u16 x,u16 y,u8 isPenDown){
	isLockPenDown = isPenDown;
	if(x>0 && x < 32768){
		mouseAbsPosX = x>>8;
		mouseAbsPosX |= (x&0XFF)<<8;
	}
	if(y > 0 && y < 32768){
		mouseAbsPosY = y>>8;
		mouseAbsPosY |= (y&0XFF)<<8;
	}
};


char code MOUSEREPORTDESC[] =
{
	0x05, 0x01,        // USAGE_PAGE (Generic Desktop)
	0x09, 0x02,        // USAGE (Mouse)
	0xa1, 0x01,        // COLLECTION (Application)
	0x09, 0x01,        //   USAGE (Pointer)
	0xa1, 0x00,        //   COLLECTION (Physical)
	0x05, 0x09,        //     USAGE_PAGE (Button)
	0x19, 0x01,        //     USAGE_MINIMUM (Button 1)
	0x29, 0x03,        //     USAGE_MAXIMUM (Button 3)
	0x15, 0x00,        //     LOGICAL_MINIMUM (0)
	0x25, 0x01,        //     LOGICAL_MAXIMUM (1)
	0x95, 0x03,        //     REPORT_COUNT (3)
	0x75, 0x01,        //     REPORT_SIZE (1)
	0x81, 0x02,        //     INPUT (Data,Var,Abs)
	0x95, 0x01,        //     REPORT_COUNT (1)
	0x75, 0x05,        //     REPORT_SIZE (5)
	0x81, 0x03,        //     INPUT (Cnst,Var,Abs)
	0x05, 0x01,        //     USAGE_PAGE (Generic Desktop)
	0x09, 0x30,        //     USAGE (X)
	0x09, 0x31,        //     USAGE (Y)
	0x15, 0x00,        //     LOGICAL_MINIMUM (0)
	0x26, 0xff, 0x7f,  //     LOGICAL_MAXIMUM (32767)
	0x75, 0x10,        //     REPORT_SIZE (16)
	0x95, 0x02,        //     REPORT_COUNT (2)
	0x81, 0x02,        //     INPUT (Data,Var,Abs)
	0xc0,              //   END_COLLECTION
	0xc0               // END_COLLECTION
//    0x05,0x01,              //USAGE_PAGE(Generic Desktop);
//    0x09,0x02,              //USAGE(Mouse);
//    0xa1,0x01,              //COLLECTION(Application);
//    0x09,0x01,              //  USAGE(Pointer);
//    0xa1,0x00,              //  COLLECTION(Physical);
//    0x05,0x09,              //    USAGE_PAGE(Buttons);
//    0x19,0x01,              //    USAGE_MINIMUM(1);
//    0x29,0x03,              //    USAGE_MAXIMUM(3);
//    0x15,0x00,              //    LOGICAL_MINIMUM(0);
//    0x25,0x01,              //    LOGICAL_MAXIMUM(1);
//    0x75,0x01,              //    REPORT_SIZE(1);
//    0x95,0x03,              //    REPORT_COUNT(3);
//    0x81,0x02,              //    INPUT(Data,Variable,Absolute);
//    0x75,0x05,              //    REPORT_SIZE(5);
//    0x95,0x01,              //    REPORT_COUNT(1);
//    0x81,0x01,              //    INPUT(Constant);
//    0x05,0x01,              //    USAGE_PAGE(Generic Desktop);
//    0x09,0x30,              //    USAGE(X);
//    0x09,0x31,              //    USAGE(Y);
//    0x15,0x81,              //    LOGICAL_MINIMUM(-127);
//    0x25,0x7f,              //    LOGICAL_MAXIMUM(127);
//    0x75,0x08,              //    REPORT_SIZE(8);
//    0x95,0x02,              //    REPORT_COUNT(2);
//    0x81,0x06,              //    INPUT(Data, Variable, Relative);
//    0xc0,                   //  END_COLLECTION;
//    0xc0,                   //END_COLLECTION;
};
char code MOUSECONFIGDESC[25] =
{
		0x09,                   //bLength(9);
    0x04,                   //bDescriptorType(Interface);
    Mouse_InterfaceNum,                   //bInterfaceNumber(1);
    0x00,                   //bAlternateSetting(0);
    0x01,                   //bNumEndpoints(1);
    0x03,                   //bInterfaceClass(HID);
    0x01,                   //bInterfaceSubClass(Boot);
    0x02,                   //bInterfaceProtocol(Mouse);
    0x00,                   //iInterface(0);

    0x09,                   //bLength(9);
    0x21,                   //bDescriptorType(HID);
    0x01,0x01,              //bcdHID(1.01);
    0x00,                   //bCountryCode(0);
    0x01,                   //bNumDescriptors(1);
    0x22,                   //bDescriptorType(HID Report);
    sizeof(MOUSEREPORTDESC),0x00,              //wDescriptorLength;

    0x07,                   //bLength(7);
    0x05,                   //bDescriptorType(Endpoint);
    0x80 | Mouse_EP,                   //bEndpointAddress(EndPoint2 as IN);
    0x03,                   //bmAttributes(Interrupt);
    Mouse_IN_SIZE,0x00,              //wMaxPacketSize(3);
    0x0a,                   //bInterval(10ms);
};
void mouseInFun()
{
    BYTE csr;

    usb_write_reg(INDEX, Mouse_EP);
    csr = usb_read_reg(INCSR1);
    if (csr & INSTSTL)
    {
        usb_write_reg(INCSR1, INCLRDT);
    }
    if (csr & INUNDRUN)
    {
        usb_write_reg(INCSR1, 0);
    }

    mouseInBusy = 0;
}
void initMouse(){
	  P3M0 = 0x00; P3M1 = 0x00; 
		mouseInBusy = 0;
		lastMouseCode = 0xFF;
		set_usb_ep_callback(Mouse_EP,64,mouseInFun,0,0);
		usb_add_interface(Mouse_InterfaceNum,MOUSECONFIGDESC,sizeof(MOUSECONFIGDESC));
		usb_add_hidDesc(Mouse_InterfaceNum,MOUSEREPORTDESC,sizeof(MOUSEREPORTDESC));
		isPenModel = 0;
		isLockPenDown = 0;
		lastMouseAbsPosX = 0;
		lastMouseAbsPosY = 0;

		mouseAbsPosX = 0;
		mouseAbsPosY = 0;
};

void mouseRun(u8 inputCode){
		BYTE button[Mouse_IN_SIZE];
		BYTE i;
		BYTE tempCode = (bKeyCode >> 2) & 0x03;	
		BYTE isSendReport = 0;
		u16* p16;
		if(inputCode == 1){
			//лģʽ
			isPenModel = !isPenModel;
		}
//		if(inputCode == 2){
//			//津ص
//			isLockPenDown = !isLockPenDown;
//		}
		if (!mouseInBusy)
		{
				
				fKeyOK = 0;
				memset(button,0,sizeof(button));
				
				if(isPenModel){
						// ģʽ
						button[0] = isLockPenDown?0x01:0x00;
					
						if(mouseAbsPosX != lastMouseAbsPosX ||
								mouseAbsPosY != lastMouseAbsPosY ){
								
						}
								lastMouseAbsPosX = mouseAbsPosX;
								lastMouseAbsPosY = mouseAbsPosY;
								p16 = (u16*)&button[1];
								*p16  = mouseAbsPosX;
								p16 = (u16*)&button[3];
								*p16   = mouseAbsPosY;
									
								isSendReport = 1;
						
				}else if(inputCode != lastMouseCode){
					lastMouseCode = inputCode;
					switch (inputCode)
					{
							//case 0x02:  button[0] = 0x01; button[1] = 0xCE; button[2] = 0xCE; break; //P34  λƣϽƶ-50-50
							//case 0x01:  button[0] = 0x02; button[1] = 0x64; button[2] = 0x64;break;//P35  Ҽλƣ½ƶ100100
							case 0:  button[0] = 0x01; break;
							case 4:  button[0] = 0x02; break;
							case 5:  button[0] = 0x04; break;
							default: button[0] = 0;break;
					}
					isSendReport = 1;
				}
				if(isSendReport){
					//IE2 &= ~EUSB;
					EUSB = 0;
					mouseInBusy = 1;
					usb_write_reg(INDEX, Mouse_EP);
					for (i=0; i<5; i++)
					{
							usb_write_reg(FIFO0+Mouse_EP, button[i]);
					}
					usb_write_reg(INCSR1, INIPRDY);
					//IE2 |= EUSB;
					EUSB = 1;
				}
		}
};