import serial
import time


def send_bin_files_to_serial(file_paths, port, baudrate, packet_size=51200):
    try:
        ser = serial.Serial(port, baudrate)
        datas=[]
        for file_path in file_paths:
            try:
                with open(file_path, 'rb') as file:
                    data = file.read()
                    datas.append(data)
            except FileNotFoundError:
                print(f"文件 {file_path} 未找到。")
        while True:
            for data in datas:    
                for i in range(0, len(data), packet_size):
                                packet = data[i:i + packet_size]
                                ser.write(packet)
                                time.sleep(0.001)  # 可根据实际情况调整
    except serial.SerialException as e:
        print(f"串口连接错误: {e}")
    except Exception as e:
        print(f"发生未知错误: {e}")


if __name__ == "__main__":
    file_paths = ['1.bin', '2.bin', '3.bin']
    port = 'COM15'  # 根据实际情况修改串口名称
    baudrate = 7500000 #5000000 #10000000  # 根据实际情况修改波特率
    send_bin_files_to_serial(file_paths, port, baudrate)
    